SystemOrganization addCategory: #'Pier-Tests-Book'!

TestCase subclass: #BOEPUBViewTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Book'!

!BOEPUBViewTest methodsFor: 'tests' stamp: 'YanniChiu 3/7/2012 11:11'!
exampleRootWithBook
	^ (PRPage named: 'root')
		title: 'Root';
		contents: 'Root stuff';
		addChild: (BOBook named: 'book1');
		yourself! !

!BOEPUBViewTest methodsFor: 'tests' stamp: 'YanniChiu 3/7/2012 12:43'!
testMetadata
	| root book epubview zip response content mimetypeMember |

	root := self exampleRootWithBook.
	book := root lookupPath: 'book1'.
	epubview := BOEPUBView on: (PRContext new setStructure: book).
	response := BOEPUBMockResponse new.
	epubview respondUsing: response.
	zip := ZipArchive new.
	zip readFrom: response stream.

	mimetypeMember := zip memberNamed: 'mimetype'.
	self assert: mimetypeMember notNil.
	self assert: mimetypeMember contents = 'application/epub+zip'.

	self assert: (zip memberNamed: 'META-INF/container.xml') notNil.
	self assert: (zip memberNamed: 'OEBPS/content.opf') notNil.
	self assert: (zip memberNamed: 'OEBPS/toc.ncx') notNil.
	self assert: (zip memberNamed: 'OEBPS/book1.html') notNil.
! !

Object subclass: #BOEPUBMockResponse
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Book'!

!BOEPUBMockResponse methodsFor: 'accessing' stamp: 'YanniChiu 3/7/2012 11:04'!
attachmentWithFileName: ignored
	"Do nothing"! !

!BOEPUBMockResponse methodsFor: 'accessing' stamp: 'YanniChiu 3/7/2012 11:04'!
binary
	"Do nothing"! !

!BOEPUBMockResponse methodsFor: 'accessing' stamp: 'YanniChiu 3/7/2012 11:04'!
cacheForever
	"Do nothing"! !

!BOEPUBMockResponse methodsFor: 'accessing' stamp: 'YanniChiu 3/7/2012 11:04'!
contentType: ignored
	"Do nothing"! !

!BOEPUBMockResponse methodsFor: 'accessing' stamp: 'YanniChiu 3/7/2012 11:04'!
stream

	^ stream ifNil: [ stream := (RWBinaryOrTextStream on: String new) binary ]! !

!BOEPUBMockResponse methodsFor: 'accessing' stamp: 'YanniChiu 3/7/2012 11:04'!
stream: anObject

	stream := anObject! !
